/***
*  camarilladt3.mq4
*  Camarilla Calculator
*  Written by: Daniel Tyrkiel
****/

#property indicator_chart_window
#property indicator_buffers 6

#property indicator_color1 Green
#property indicator_color2 Green
#property indicator_color3 Green
#property indicator_color4 Red
#property indicator_color5 Red
#property indicator_color6 Red

//---- input parameters\

extern string StartTime = "06:00";
extern string EndTime = "05:45";
double ch3, ch4, ch5, cl3,cl4, cl5;
//double x;
double pivotOpen=0;
double pivotHigh=0;
double pivotLow=0;
double pivotClose=0;
//double D1=0.091667;
//double D2=0.183333;
double D3=0.2750;
double D4=0.55;
bool pivotStarted=false;
bool pivotCompleted=false;
string camh3, camh4, camh5, caml3, caml4, caml5;


// buffers
double CH3[];
double CH4[];
double CH5[];
double CL3[];
double CL4[];
double CL5[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
//---- indicators


SetIndexStyle(0, DRAW_LINE, STYLE_SOLID);
SetIndexBuffer(0, CH3);

SetIndexStyle(1, DRAW_LINE, STYLE_SOLID);
SetIndexBuffer(1, CH4);

SetIndexStyle(2, DRAW_LINE, STYLE_SOLID);
SetIndexBuffer(2, CH5);

SetIndexStyle(3, DRAW_LINE, STYLE_SOLID);
SetIndexBuffer(3, CL3);

SetIndexStyle(4, DRAW_LINE, STYLE_SOLID);
SetIndexBuffer(4, CL4);

SetIndexStyle(5, DRAW_LINE, STYLE_SOLID);
SetIndexBuffer(5, CL5);

   ObjectCreate("camh3", OBJ_ARROW, 0, 0, 0);
   ObjectSet("camh3",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
   ObjectCreate("camh4", OBJ_ARROW, 0, 0, 0);
   ObjectSet("camh4",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
   ObjectCreate("camh5", OBJ_ARROW, 0, 0, 0);
   ObjectSet("camh5",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
   ObjectCreate("caml3", OBJ_ARROW, 0, 0, 0);
   ObjectSet("caml3",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
   ObjectCreate("caml4", OBJ_ARROW, 0, 0, 0);
   ObjectSet("caml4",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
   ObjectCreate("caml5", OBJ_ARROW, 0, 0, 0);
   ObjectSet("caml5",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
   
return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function |
//+------------------------------------------------------------------+
int deinit()
{  
   ObjectDelete("camh3");
   ObjectDelete("camh4");
   ObjectDelete("camh5");
   ObjectDelete("caml3");
   ObjectDelete("caml4");
   ObjectDelete("caml5");  

return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{

//  int    counted_bars=IndicatorCounted();

//int limit;
//+------------------------------------------------------------------+
//| Indicator calculation                                            |
//+------------------------------------------------------------------+
//if (counted_bars==0)
//{
//   x=Period();
//   if (x>240) return(-1);
   
  
//}
//   if(counted_bars<0) return(-1);
   
   for(int i=Bars; i>=0; i--)
   {
      calcPivots(i);
      
      CL3[i] = cl3;
      CL4[i] = cl4;
      CL5[i] = cl5;
      CH3[i] = ch3;
      CH4[i] = ch4;
      CH5[i] = ch5;
   }
}

void calcPivots(int curBar)
{
   string barTime;
   
   barTime = TimeToStr(Time[curBar], TIME_MINUTES);
       
   if (barTime==StartTime)
   {
     pivotOpen = Open[curBar];
     pivotLow = Low[curBar];
     pivotHigh = High[curBar];
     pivotStarted=true;
   }

   if (pivotStarted && barTime==EndTime)
   {   
     pivotClose = Close[curBar];
     pivotCompleted=true; 
   }

   if (pivotStarted && pivotHigh<High[curBar])
   {
      pivotHigh=High[curBar];
   } 

   if (pivotStarted && pivotLow>Low[curBar]) 
   {
      pivotLow=Low[curBar];
   }  

   if (pivotCompleted && pivotLow!=0)
   {
      ch5 = (pivotHigh/pivotLow)*pivotClose;
      ch4 = ((pivotHigh - pivotLow)* D4) + pivotClose;
      ch3 = ((pivotHigh - pivotLow)* D3) + pivotClose;
//ch2 = ((pivotHigh - pivotLow) * D2) + pivotClose;
//ch1 = ((pivotHigh - pivotLow) * D1) + pivotClose;

//cl1 = pivotClose - ((pivotHigh - pivotLow)*(D1));
//cl2 = pivotClose - ((pivotHigh - pivotLow)*(D2));
      cl3 = pivotClose - ((pivotHigh - pivotLow)*(D3));
      cl4 = pivotClose - ((pivotHigh - pivotLow)*(D4));     
      cl5 = pivotClose - (ch5 - pivotClose);
      
      ObjectMove("camh3", 0, Time[0],ch3);
      ObjectMove("camh4", 0, Time[0],ch4);
      ObjectMove("camh5", 0, Time[0],ch5);
      ObjectMove("caml3", 0, Time[0],cl3);
      ObjectMove("caml4", 0, Time[0],cl4);
      ObjectMove("caml5", 0, Time[0],cl5); 
      
      pivotStarted = false;
      pivotCompleted = false; 
      
   
   }
   
   
}